
DefInt A-P
DefSng R-Z
Dim Shared MetaDC%   'Device context
Dim Shared MetaErrorcode As Integer
Dim Shared PenHandle As Integer
Dim Shared BrushHandle As Integer
Dim Shared kx, ky As Single
Dim Shared MetaFileName$
Dim Shared DrawWidthFactor  As Integer
Dim Shared FontAngleFactor As Integer
Dim Shared FontHandle
Dim x0 As Integer, y0 As Integer, WWidth As Integer, WHeight As Integer

Type HeaderType
  key As Long
  handle As Integer
  x1 As Integer
  y1 As Integer
  x2  As Integer
  y2 As Integer
  inch As Integer
  res As Long
  checksum As Integer
End Type


'Constants for the DrawText api call
'
Global Const DT_TOP = &H0
Global Const DT_LEFT = &H0
Global Const DT_CENTER = &H1
Global Const DT_RIGHT = &H2
Global Const DT_VCENTER = &H4
Global Const DT_BOTTOM = &H8
Global Const DT_WORDBREAK = &H10
Global Const DT_SINGLELINE = &H20
Global Const DT_EXPANDTABS = &H40
Global Const DT_TABSTOP = &H80
Global Const DT_NOCLIP = &H100
Global Const DT_EXTERNALLEADING = &H200
Global Const DT_CALCRECT = &H400
Global Const DT_NOPREFIX = &H800
Global Const DT_INTERNAL = &H1000
 
Global Const ZERO = 0&
Global Const LF_FACESIZE = 32
Global Const OUT_DEFAULT_PRECIS = 0
Global Const OUT_STRING_PRECIS = 1
Global Const OUT_CHARACTER_PRECIS = 2
Global Const OUT_STROKE_PRECIS = 3
 
Global Const CLIP_DEFAULT_PRECIS = 0
Global Const CLIP_CHARACTER_PRECIS = 1
Global Const CLIP_STROKE_PRECIS = 2
 
Global Const DEFAULT_QUALITY = 0
Global Const DRAFT_QUALITY = 1
Global Const PROOF_QUALITY = 2
 
Global Const DEFAULT_PITCH = 0
Global Const FIXED_PITCH = 1
Global Const VARIABLE_PITCH = 2
 
Global Const ANSI_CHARSET = 0
Global Const SYMBOL_CHARSET = 2
Global Const SHIFTJIS_CHARSET = 128
Global Const OEM_CHARSET = 255
 
'  Font Families
'
Global Const FF_DONTCARE = 0    '  Don't care or don't know.
Global Const FF_ROMAN = 16  '  Variable stroke width, serifed.
 
'  Times Roman, Century Schoolbook, etc.
Global Const FF_SWISS = 32  '  Variable stroke width, sans-serifed.
 
'  Helvetica, Swiss, etc.
Global Const FF_MODERN = 48 '  Constant stroke width, serifed or sans-serifed.
 
'  Pica, Elite, Courier, etc.
Global Const FF_SCRIPT = 64 '  Cursive, etc.
Global Const FF_DECORATIVE = 80 '  Old English, etc.
 
'  Font Weights
Global Const FW_DONTCARE = 0
Global Const FW_THIN = 100
Global Const FW_EXTRALIGHT = 200
Global Const FW_LIGHT = 300
Global Const FW_NORMAL = 400
Global Const FW_MEDIUM = 500
Global Const FW_SEMIBOLD = 600
Global Const FW_BOLD = 700
Global Const FW_EXTRABOLD = 800
Global Const FW_HEAVY = 900
 
Global Const FW_ULTRALIGHT = FW_EXTRALIGHT
Global Const FW_REGULAR = FW_NORMAL
Global Const FW_DEMIBOLD = FW_SEMIBOLD
Global Const FW_ULTRABOLD = FW_EXTRABOLD
Global Const FW_BLACK = FW_HEAVY
Global Const MM_TEXT = 1
Global Const MM_LOMETRIC = 2
Global Const MM_HIMETRIC = 3
Global Const MM_LOENGLISH = 4
Global Const MM_HIENGLISH = 5
Global Const MM_TWIPS = 6
Global Const MM_ISOTROPIC = 7
Global Const MM_ANISOTROPIC = 8

'  Device Parameters for GetDeviceCaps()
Global Const DRIVERVERSION = 0  '  Device driver version
Global Const TECHNOLOGY = 2   '  Device classification
Global Const HORZSIZE = 4   '  Horizontal size in millimeters
Global Const VERTSIZE = 6   '  Vertical size in millimeters
Global Const HORZRES = 8    '  Horizontal width in pixels
Global Const VERTRES = 10   '  Vertical width in pixels
Global Const BITSPIXEL = 12 '  Number of bits per pixel
Global Const PLANES = 14    '  Number of planes
Global Const NUMBRUSHES = 16    '  Number of brushes the device has
Global Const NUMPENS = 18   '  Number of pens the device has
Global Const NUMMARKERS = 20    '  Number of markers the device has
Global Const NUMFONTS = 22  '  Number of fonts the device has
Global Const NUMCOLORS = 24 '  Number of colors the device supports
Global Const PDEVICESIZE = 26   '  Size required for device descriptor
Global Const CURVECAPS = 28 '  Curve capabilities
Global Const LINECAPS = 30  '  Line capabilities
Global Const POLYGONALCAPS = 32 'Polygonal capabilities
Global Const TEXTCAPS = 34   '  Text capabilities
Global Const CLIPCAPS = 36  '  Clipping capabilities
Global Const RASTERCAPS = 38    '  Bitblt capabilities
Global Const ASPECTX = 40   '  Length of the X leg
Global Const ASPECTY = 42   '  Length of the Y leg
Global Const ASPECTXY = 44  '  Length of the hypotenuse
Global Const LOGPIXELSX = 88    '  Logical pixels/inch in X
Global Const LOGPIXELSY = 90    '  Logical pixels/inch in Y
Global Const SIZEPALETTE = 104  '  Number of entries in physical palette
Global Const NUMRESERVED = 106  '  Number of reserved entries in palette
Global Const COLORRES = 108 '  Actual color resolution
'  Device Capability Masks:
'  Device Technologies
Global Const DT_PLOTTER = 0             '  Vector plotter
Global Const DT_RASDISPLAY = 1          'Raster display
Global Const DT_RASPRINTER = 2          '  Raster printer
Global Const DT_RASCAMERA = 3           'Raster camera
Global Const DT_CHARSTREAM = 4          'Character-stream, PLP
Global Const DT_METAFILE = 5            'Metafile, VDM
Global Const DT_DISPFILE = 6            '  Display-file
'  Curve Capabilities
Global Const CC_NONE = 0                '  Curves not supported
Global Const CC_CIRCLES = 1             '  Can do circles
Global Const CC_PIE = 2                 '  Can do pie wedges
Global Const CC_CHORD = 4               '  Can do chord arcs
Global Const CC_ELLIPSES = 8            '  Can do ellipese
Global Const CC_WIDE = 16               '  Can do wide lines
Global Const CC_STYLED = 32             '  Can do styled lines
Global Const CC_WIDESTYLED = 64         '  Can do wide styled lines
Global Const CC_INTERIORS = 128         '  Can do interiors
'  Line Capabilities
Global Const LC_NONE = 0                '  Lines not supported
Global Const LC_POLYLINE = 2            '  Can do polylines
Global Const LC_MARKER = 4              '  Can do markers
Global Const LC_POLYMARKER = 8          '  Can do polymarkers
Global Const LC_WIDE = 16               '  Can do wide lines
Global Const LC_STYLED = 32             '  Can do styled lines
Global Const LC_WIDESTYLED = 64         '  Can do wide styled lines
Global Const LC_INTERIORS = 128         '  Can do interiors
'  Polygonal Capabilities
Global Const PC_NONE = 0                '  Polygonals not supported
Global Const PC_POLYGON = 1             '  Can do polygons
Global Const PC_RECTANGLE = 2           '  Can do rectangles
Global Const PC_WINDPOLYGON = 4         '  Can do winding polygons
Global Const PC_TRAPEZOID = 4           '  Can do trapezoids
Global Const PC_SCANLINE = 8            '  Can do scanlines
Global Const PC_WIDE = 16               '  Can do wide borders
Global Const PC_STYLED = 32             '  Can do styled borders
Global Const PC_WIDESTYLED = 64         '  Can do widestyled borders
Global Const PC_INTERIORS = 128         '  Can do interiors
'  Polygonal Capabilities
Global Const CP_NONE = 0                '  No clippingof output
Global Const CP_RECTANGLE = 1           '  Output clipped to rects
'  Text Capabilities
Global Const TC_OP_CHARACTER = &H1      '  Can do OutputPrecision CHARACTER
Global Const TC_OP_STROKE = &H2         '  Can do OutputPrecision STROKE
Global Const TC_CP_STROKE = &H4         '  Can do ClipPrecision STROKE
Global Const TC_CR_90 = &H8             '  Can do CharRotAbility  90
Global Const TC_CR_ANY = &H10           '  Can do CharRotAbility  ANY
Global Const TC_SF_X_YINDEP = &H20      '  Can do ScaleFreedom X_YINDEPENDENT
Global Const TC_SA_DOUBLE = &H40        '  Can do ScaleAbility DOUBLE
Global Const TC_SA_INTEGER = &H80       '  Can do ScaleAbility INTEGER
Global Const TC_SA_CONTIN = &H100       '  Can do ScaleAbility CONTINUOUS
Global Const TC_EA_DOUBLE = &H200       '  Can do EmboldenAbility       DOUBLE
Global Const TC_IA_ABLE = &H400         '  Can do ItalisizeAbility  ABLE
Global Const TC_UA_ABLE = &H800         '  Can do UnderlineAbility  ABLE
Global Const TC_SO_ABLE = &H1000        '  Can do StrikeOutAbility      ABLE
Global Const TC_RA_ABLE = &H2000        '  Can do RasterFontAble        ABLE
Global Const TC_VA_ABLE = &H4000        '  Can do VectorFontAble        ABLE
Global Const TC_RESERVED = &H8000

'  Brush Styles
Global Const BS_SOLID = 0
Global Const BS_NULL = 1
Global Const BS_HOLLOW = BS_NULL
Global Const BS_HATCHED = 2
Global Const BS_PATTERN = 3
Global Const BS_INDEXED = 4
Global Const BS_DIBPATTERN = 5
 
'  Hatch Styles
Global Const HS_HORIZONTAL = 0  '  -----
Global Const HS_VERTICAL = 1    '  |||||
Global Const HS_FDIAGONAL = 2   '  \\\\\
Global Const HS_BDIAGONAL = 3   '  /////
Global Const HS_CROSS = 4   '  +++++
Global Const HS_DIAGCROSS = 5   '  xxxxx
 
'  Pen Styles
Global Const PS_SOLID = 0
Global Const PS_DASH = 1    '  -------
Global Const PS_DOT = 2 '  .......
Global Const PS_DASHDOT = 3 '  _._._._
Global Const PS_DASHDOTDOT = 4  '  _.._.._
Global Const PS_NULL = 5
Global Const PS_INSIDEFRAME = 6

Type Rect
    left As Integer
    Top As Integer
    right As Integer
    bottom As Integer
End Type

Type POINTAPI
    x As Integer
    y As Integer
End Type

Type PAINTSTRUCT
    hDC As Integer
    ferase As Integer
    rcpaint As Rect
    fRestore As Integer
    fIncUpdate As Integer
    rgbReserved As String * 16
End Type

Type RGBTRIPLE
    rgbtBlue As String * 1
    rgbtGreen As String * 1
    rgbtRed As String * 1
End Type

'  Logical Brush (or Pattern)
Type LOGBRUSH
    lbStyle As Integer
    lbColor As Long
    lbHatch As Integer
End Type
 
'  Logical Pen
Type LOGPEN
    lopnStyle As Integer
    lopnWidth As POINTAPI
    lopnColor As Long
End Type

Type LOGFONT
    lfHeight As Integer
    lfWidth As Integer
    lfEscapement As Integer
    lfOrientation As Integer
    lfWeight As Integer
    lfItalic As String * 1
    lfUnderline As String * 1
    lfStrikeOut As String * 1
    lfCharSet As String * 1
    lfOutPrecision As String * 1
    lfClipPrecision As String * 1
    lfQuality As String * 1
    lfPitchAndFamily As String * 1
    lfFaceName As String * LF_FACESIZE
End Type

Global FontType As LOGFONT
Global BrushType As LOGBRUSH
Global gDrawRectangle As Rect


Global gMdc%             'metafile device context
Global gHmf%             'Metafile Handle

Declare Function DrawText Lib "GDI" (ByVal hDC As Integer, ByVal lpStr As String, ByVal nCount As Integer, lpRect As Rect, ByVal wFormat As Integer) As Integer
Declare Function TextOut Lib "GDI" (ByVal hDC As Integer, ByVal x As Integer, ByVal y As Integer, ByVal lpString As String, ByVal nCount As Integer) As Integer
Declare Function CreateFontIndirect Lib "GDI" (lpLogFont As LOGFONT) As Integer
Declare Function FloodFill Lib "GDI" (ByVal hDC As Integer, ByVal x As Integer, ByVal y As Integer, ByVal crColor As Long) As Integer
Declare Function ExtFloodFill Lib "GDI" (ByVal hDC As Integer, ByVal x As Integer, ByVal y As Integer, ByVal crColor As Long, ByVal wFillType As Integer) As Integer

Declare Function SetTextJustification Lib "GDI" (ByVal hDC As Integer, ByVal nBreakExtra As Integer, ByVal nBreakCount As Integer) As Integer
Declare Function GetTextExtent Lib "GDI" (ByVal hDC As Integer, ByVal lpString As String, ByVal nCount As Integer) As Long
Declare Function DeleteObject Lib "GDI" (ByVal hObject As Integer) As Integer
Declare Function CreatePen Lib "GDI" (ByVal nPenStyle As Integer, ByVal nWidth As Integer, ByVal crColor As Long) As Integer
Declare Function CreatePenIndirect Lib "GDI" (lpLogPen As LOGPEN) As Integer
Declare Function CreateSolidBrush Lib "GDI" (ByVal crColor As Long) As Integer
Declare Function CreateHatchBrush Lib "GDI" (ByVal nIndex As Integer, ByVal crColor As Long) As Integer
Declare Function CreateBrushIndirect Lib "GDI" (lpLogBrush As LOGBRUSH) As Integer
Declare Function SelectObject Lib "GDI" (ByVal hDC As Integer, ByVal hObject As Integer) As Integer
Declare Function SetBkColor Lib "GDI" (ByVal hDC As Integer, ByVal crColor As Long) As Long
Declare Function GetBkColor Lib "GDI" (ByVal hDC As Integer) As Long
Declare Function SetBkMode Lib "GDI" (ByVal hDC As Integer, ByVal nBkMode As Integer) As Integer
Declare Function GetBkMode Lib "GDI" (ByVal hDC As Integer) As Integer
Declare Function SetTextColor Lib "GDI" (ByVal hDC As Integer, ByVal crColor As Long) As Long
Declare Function GetTextColor Lib "GDI" (ByVal hDC As Integer) As Long
Declare Function SetTextAlign Lib "GDI" (ByVal hDC As Integer, ByVal wFlags As Integer) As Integer
Declare Function GetTextAlign Lib "GDI" (ByVal hDC As Integer) As Integer
Declare Function GetFocus Lib "User" () As Integer
Declare Sub GetClientRect Lib "User" (ByVal hWnd As Integer, lpRect As Rect)
Declare Function DeleteMetaFile Lib "GDI" (ByVal gHmf As Integer) As Integer
Declare Function CreateMetaFile Lib "GDI" (ByVal lpString As Any) As Integer
Declare Function rectangle% Lib "GDI" (ByVal hDC%, ByVal x1%, ByVal y1%, ByVal x2%, ByVal y2%)
Declare Function Arc Lib "GDI" (ByVal hDC As Integer, ByVal x1 As Integer, ByVal y1 As Integer, ByVal x2 As Integer, ByVal y2 As Integer, ByVal X3 As Integer, ByVal Y3 As Integer, ByVal X4 As Integer, ByVal Y4 As Integer) As Integer
Declare Function MoveTo Lib "GDI" (ByVal hDC As Integer, ByVal x As Integer, ByVal y As Integer) As Long
Declare Function LineTo Lib "GDI" (ByVal hDC As Integer, ByVal x As Integer, ByVal y As Integer) As Integer
Declare Function CloseMetaFile% Lib "GDI" (ByVal hDC%)
Declare Function PlayMetaFile% Lib "GDI" (ByVal hDC%, ByVal gHmf%)
Declare Function Ellipse Lib "GDI" (ByVal hDC As Integer, ByVal x1 As Integer, ByVal y1 As Integer, ByVal x2 As Integer, ByVal y2 As Integer) As Integer
Declare Function GetMetaFileBits Lib "GDI" (ByVal gHmf As Integer) As Integer
Declare Function CopyMetaFile Lib "GDI" (ByVal gHmf As Integer, ByVal lpFilename As String) As Integer
Declare Function setMapMode Lib "GDI" (ByVal hDC As Integer, ByVal nMapMode As Integer) As Integer
Declare Function SetWindowExt Lib "GDI" (ByVal hDC As Integer, ByVal x As Integer, ByVal y As Integer) As Long
Declare Function SetViewPortExt Lib "GDI" (ByVal hDC As Integer, ByVal x As Integer, ByVal y As Integer) As Long
Declare Function SetWindowOrg Lib "GDI" (ByVal hDC As Integer, ByVal x As Integer, ByVal y As Integer) As Long
Declare Function BeginPaint Lib "User" (ByVal hWnd As Integer, lpPaint As PAINTSTRUCT) As Integer
Declare Function GetDeviceCaps Lib "GDI" (ByVal hDC As Integer, ByVal nIndex As Integer) As Integer
Declare Function GetMetaFile Lib "GDI" (ByVal lpFilename As String) As Integer
 
Declare Function SetPixel Lib "GDI" (ByVal hDC As Integer, ByVal x As Integer, ByVal y As Integer, ByVal Colorref As Long) As Long

Sub EndMetafile (Clipboardflag)
'Metafile schliessen
'bei Clipboardflag=1,2 nach Clipboard kopieren
'bei Clipboardflag=2 wird Clipboard (auch Text !) gelscht

   k% = CloseMetaFile(MetaDC%)
   'Handle wieder freigeben
   h% = DeleteMetaFile(MetaDC%)

'nach Clipboard kopieren
If Clipboardflag Then
  If Clipboardflag And 2 Then Clipboard.Clear
  AddAdobeHeader MetaFileName$, (x0), (y0), (x0 + WWidth), Abs(y0 + WHeight), (kx * 25.4)
  Clipboard.SetData LoadPicture(MetaFileName$), 3
End If

'Fehler ?
If MetaErrorcode Then
   s$ = "Error creating metafile !"
   MsgBox s$, 64
End If




End Sub

Sub MetaArc (x1, y1, x2, y2, X3, Y3)
'Bogen mit Zentrum (x1,y1)
'von Punkt (x2,y2) nach (x3,y3) in Gegenuhrzeigersinn

Dim xA, yA, xB, yB, xC, yC, xD, yD As Integer

Radius = Sqr((x2 - x1) ^ 2 + (y2 - y1) ^ 2)
xA = (x1 - Radius) * kx
xB = (x1 + Radius) * kx
yA = (y1 - Radius) * ky
yB = (y1 + Radius) * ky
xC = x2 * kx
yC = y2 * ky
xD = X3 * kx
yD = Y3 * ky
ok% = Arc(MetaDC%, xA, yA, xB, yB, xC, yC, xD, yD)

End Sub

Sub MetaArc1 (x1, y1, Radius, alpha1!, alpha2!)

Dim xA, yA, xB, yB, xC, yC, xD, yD As Integer


xA = (x1 - Radius) * kx
xB = (x1 + Radius) * kx
yA = (y1 - Radius) * ky
yB = (y1 + Radius) * ky
xC = x1 * kx + Radius * kx * Cos(alpha1!)
yC = y1 * ky - Radius * ky * Sin(alpha1!)
xD = x1 * kx + Radius * kx * Cos(alpha2!)
yD = y1 * ky - Radius * ky * Sin(alpha2!)
ok% = Arc(MetaDC%, xA, yA, xB, yB, xC, yC, xD, yD)

End Sub

Sub MetaCircle (x, y, r)

Dim x1, y1, x2, y2 As Integer

x1 = (x - r) * kx
y1 = (y - r) * ky
x2 = (x + r) * kx
y2 = (y + r) * ky

c = Ellipse(MetaDC%, x1, y1, x2, y2)
End Sub

Sub MetaFloodFill (x1, y1, AreaColor As Long)
 
a = ExtFloodFill(MetaDC%, Int(x1 * kx), Int(y1 * ky), AreaColor, 1)

End Sub

Sub MetaInitFont (Pic As Control, Angle As Integer, Alignmentflag As Integer)

Dim Font As LOGFONT

'Get Info about Picture font
szFaceName$ = Space$(80)
retval% = GetTextFace(Pic.hDC, 79, szFaceName$)


Dim lpMetrics As Textmetric
B% = GetTextMetrics(Pic.hDC, lpMetrics)

Select Case lpMetrics.tmHeight
  Case Is > 8
    CorrectFactor! = 1.41
  Case Else
    szFaceName$ = "Small fonts"
    CorrectFactor! = 1.88
End Select

Font.lfHeight = lpMetrics.tmHeight * Abs(ky) * .351 / CorrectFactor!
Font.lfWidth = 0 '-- let Windows figure out the appropriate width based on the height
Font.lfEscapement = Angle * FontAngleFactor
Font.lfOrientation = 0  '-- normal character orientation (straight up)
Font.lfPitchAndFamily = lpMetrics.tmPitchandFamily 'Chr$(33)
Font.lfCharSet = lpMetrics.tmCharset 'Chr$(OEM_CHARSET)  '-- this is important!
Font.lfQuality = Chr$(2)
Font.lfWeight = lpMetrics.tmWeight '400
Font.lfItalic = lpMetrics.tmItalic
Font.lfUnderline = lpMetrics.tmUnderlined
Font.lfStrikeOut = lpMetrics.tmStruckOut
Font.lfOutPrecision = Chr$(2) 'Chr$(0)
Font.lfClipPrecision = Chr$(0)
Font.lfFaceName = szFaceName$ + Chr$(0) '-- Windows' "Modern" font

'-- get the handle to the font we specify
If FontHandle Then ok = DeleteObject(FontHandle)
FontHandle = CreateFontIndirect(Font)
oldfont = SelectObject(MetaDC%, FontHandle)

oldAlign% = SetTextAlign(MetaDC%, Alignmentflag)



End Sub

Sub Metaline (x1, y1, x2, y2)

Dim xA, yA, xB, yB As Integer
xA = kx * x1
yA = ky * y1
xB = kx * x2
yB = ky * y2

   a& = MoveTo(MetaDC%, xA, yA)
   B& = LineTo(MetaDC%, xB, yB)


End Sub

Sub MetaRect (x1, y1, x2, y2)

Dim xA, yA, xB, yB As Integer
xA = kx * x1
yA = ky * y1
xB = kx * x2
yB = ky * y2

d& = rectangle(MetaDC%, xA, yA, xB, yB)

End Sub

Sub MetaSetBrush (BCol As Long, FStyle As Integer)
'Fllstil fr Objekte ndern
'  Brush Styles
'Global Const BS_SOLID = 0
'Global Const BS_NULL = 1
'Global Const BS_HOLLOW = BS_NULL
'Global Const BS_HATCHED = 2
'Global Const BS_PATTERN = 3
'Global Const BS_INDEXED = 4
'Global Const BS_DIBPATTERN = 5
 
'  Hatch Styles
'Global Const HS_HORIZONTAL = 0  '  -----
'Global Const HS_VERTICAL = 1    '  |||||
'Global Const HS_FDIAGONAL = 2   '  \\\\\
'Global Const HS_BDIAGONAL = 3   '  /////
'Global Const HS_CROSS = 4   '  +++++
'Global Const HS_DIAGCROSS = 5   '  xxxxx

   Select Case FStyle
     Case 0, 1
        BStyle = FStyle
     Case 2 To 7
        BStyle = BS_HATCHED
        BHatch = FStyle - 2
  End Select

   BrushType.lbStyle = BStyle
   BrushType.lbColor = QBColor(BCol)
   BrushType.lbHatch = BHatch
   
   If BrushHandle Then ok = DeleteObject(BrushHandle)

   brush% = CreateBrushIndirect(BrushType)
  BrushHandle = SelectObject(MetaDC%, brush%)

End Sub

Sub MetaSetPen (PCol&, PWidth%, PStyle%)
'Farbe PCol, Breite PWidth und Stil PStyle festlegen

     If PenHandle Then ok = DeleteObject(PenHandle)
     PenHandle = CreatePen(PStyle%, PWidth% * DrawWidthFactor, PCol&)
     PreviousHandle = SelectObject(MetaDC%, PenHandle)

    B% = SetTextColor(MetaDC%, PCol)
    
End Sub

Sub MetaSetPoint (x, y, Color&)

Dim xA As Integer, yA As Integer
xA = kx * x
yA = ky * y
c& = SetPixel(MetaDC%, xA, yA, Color&)
End Sub

Sub MetaText (x, y, text$)

Dim xA, yA As Integer
xA = kx * x
yA = ky * y

B% = TextOut(MetaDC%, xA, yA, text$, Len(text$))


End Sub

Sub AddAdobeHeader (file$, x1, y1, x2, y2, inch)
'zur normalen Metafile Adobe-Header hinzufgen,
'da sonst in VB4 oder Word nicht gltig

TmpHeaderfile$ = "c:\$$$hdr.wmf"

Dim h As HeaderType
  h.key = &H9AC6CDD7
  h.handle = 0
  h.x1 = x1
  h.y1 = y1
  h.x2 = x2
  h.y2 = y2
  h.inch = inch
  h.res = 0
  h.checksum = 0

F1% = FreeFile
Open TmpHeaderfile$ For Binary As #F1%
Put #F1%, , h
Seek #F1%, 1
For i% = 1 To 10
  Get #F1%, , c%
  crc% = crc% Xor c%
Next i%
Put #F1%, , c%

F2% = FreeFile
Open file$ For Binary As #F2%
   CopyPartFromTo F2%, F1%, 1, LOF(F2%)
 Close #F1%
 Close #F2%
 
 'Clipboard.SetData LoadPicture(TmpHeaderfile$)
 FileCopy TmpHeaderfile$, file$
 Kill TmpHeaderfile$
End Sub

Sub BeginMetafile (FileName$, xmin!, ymin!, xmax!, ymax!, MapMode%, yOrientationUpflag%)
'Metafile erzeugen
'mit xMin!...yMax!   Fenster festlegen (hat bei MapMode=MM_HIMETRIC keine Wirkung)
'Defaults festgelegt:   Farbe = schwarz.solid
'                       Mode transparent
'                       Fillstyle (Brush): leer
'yOrientationUpflag%      1  = nach oben positiv
'                         0  = nach unten positiv




MetaFileName$ = FileName$
If MetaFileName$ = "" Then MetaFileName$ = "$$$wmf.wmf"
If MapMode% = 2 Then factor% = 10 Else factor% = 100

'Masstab-Konvertierung
  kx = factor%

DrawWidthFactor% = 25
If MapMode% = MM_HIMETRIC Then
     FontAngleFactor = -10
    If yOrientationUpflag% Then    'nach oben positiv
       ky = factor%
       x0 = xmin! * kx
       'y0 = -ymin! * ky + (ymax! - ymin!) * ky
       y0 = ymax! * ky
       WWidth = (xmax! - xmin!) * kx
       WHeight = (ymax! - ymin!) * ky
    Else                           'nach unten positiv
       ky = -factor%
       x0 = xmin! * kx
       y0 = ymin! * ky
       WWidth = (xmax! - xmin!) * kx
       WHeight = (ymax! - ymin!) * ky
    End If

Else                 'MM_ANISOTROPIC
    ky = factor%
    
    If yOrientationUpflag% Then    'nach oben positiv
       FontAngleFactor = 10
       ky = -factor%
       x0 = xmin! * kx
       y0 = (ymin! * ky + (ymax! - ymin!) * ky)
       WWidth = (xmax! - xmin!) * kx
       WHeight = -(ymax! - ymin!) * ky
    Else                           'nach unten positiv
       FontAngleFactor = -10
       ky = -factor%
       x0 = xmin! * kx
       y0 = ymin! * ky
       WWidth = (xmax! - xmin!) * kx
       WHeight = (ymax! - ymin!) * ky
    End If

End If



MetaDC% = CreateMetaFile(MetaFileName$)
    If MetaDC% = 0 Then MetaErrorcode = 1

   i% = setMapMode(MetaDC%, MapMode%)
   l& = SetWindowOrg(MetaDC%, x0, y0)
   l& = SetWindowExt(MetaDC%, WWidth, WHeight)
   



   'Brush entscheidet, ob Objekte gefllt werden oder nicht
   'auch wenn Brush nicht benutzt wird !!!
    MetaSetBrush 0, 1

   'Transparentmode
   ok% = SetBkMode(MetaDC%, 1)

   'Farbe: default = 0,SOLID
     PenHandle = CreatePen(PS_SOLID, 0, 0)
     PreviousHandle = SelectObject(MetaDC%, PenHandle)
   
   
End Sub

Sub CopyPartFromTo (F1%, F2%, FromPosition&, ToPosition&)
'Kopiert einen Teil einer Datei in eine andere
'Dateien mssen geffnet sein
'  F1%/F2%  Nummer der 1./2. Datei
' FromPosition&  Anfangsposition
' ToPosition&  Schlussposition
' !! Dateien mssen schon geffnet sein  !!
' !! Zeiger der Dateien mssen bereits richtig stehen

 
 Remaining& = ToPosition& - FromPosition&
  Do
    If Remaining& > 4096 Then
      ThisPass = 4096
    Else
      ThisPass = Remaining&
    End If

    Buffer$ = Space$(ThisPass)
    Get #F1, , Buffer$
    Put #F2, , Buffer$
    Remaining& = Remaining& - ThisPass
  Loop While Remaining&

End Sub

